"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var animations_1 = require("@angular/animations");
var TabTitleComponent = (function () {
    function TabTitleComponent() {
        this.tabTitleChangeEvent = new core_1.EventEmitter();
    }
    Object.defineProperty(TabTitleComponent.prototype, "titleDatas", {
        get: function () {
            return this._titleDatas;
        },
        set: function (v) {
            this._titleDatas = v;
        },
        enumerable: true,
        configurable: true
    });
    TabTitleComponent.prototype.ngOnInit = function () {
        this.init();
    };
    TabTitleComponent.prototype.init = function () {
        if (this.titleDatas == null && this.titleDatas.length == 0) {
            return;
        }
        this.titleDatas.map(function (item) {
            item.cur = true;
        });
        this.titleDatas[0].cur = false;
        this.setDefaultTab();
    };
    // 点击tab标题
    // 点击tab标题
    TabTitleComponent.prototype.selectTitle = 
    // 点击tab标题
    function (tab) {
        this.titleDatas.map(function (item) {
            item.cur = true;
        });
        tab.cur = false;
        this.defaultTitle = tab;
        this.tabTitleChangeEvent.emit(tab);
    };
    // 设置默认tab
    // 设置默认tab
    TabTitleComponent.prototype.setDefaultTab = 
    // 设置默认tab
    function () {
        if (!this.defaultTitle) {
            this.defaultTitle = this.titleDatas[0];
        }
    };
    TabTitleComponent.decorators = [
        { type: core_1.Component, args: [{
                    selector: 'dc-tab-title',
                    template: "\n    <div class=\"tab-title-wrap\">\n      <div [class]=\"defaultTitle === item ? 'title-item active' : 'title-item'\" *ngFor=\"let item of titleDatas\" (click)=\"selectTitle(item)\">\n        {{item.title}}\n        <em class=\"line\" [@openClose]=\"item.cur ? 'open' : 'closed'\">&nbsp;</em>\n      </div>\n    </div>",
                    animations: [
                        animations_1.trigger('openClose', [
                            animations_1.state('open', animations_1.style({
                                left: '50%',
                                width: '0'
                            })),
                            animations_1.state('closed', animations_1.style({
                                left: '0',
                                width: '100%'
                            })),
                            animations_1.transition('open => closed', [
                                animations_1.animate('0.3s')
                            ]),
                            animations_1.transition('closed => open', [
                                animations_1.animate('0.1s')
                            ]),
                        ]),
                    ],
                    styles: [
                        ".tab-title-wrap {\n      border-bottom: 1px solid #d6d6d6;\n      position:relative;\n    }\n    .tab-title-wrap .title-item{\n      width: auto;\n      line-height: 20px;\n      font-size: 16px;\n      color: #666;\n      padding: 22px 0;\n      margin: 0 30px 0 20px;\n      font-weight: bold;\n      cursor: pointer;\n      display: inline-block;\n      position:relative;\n    }\n    .tab-title-wrap .title-item:hover,\n    .tab-title-wrap .active{\n      color:#3FB992;\n    }\n    .line{\n      position: absolute;\n      width:100%;\n      height: 4px ;\n      background-color: #3FB992;\n      left:0;\n      bottom:0;\n    }"
                    ]
                },] },
    ];
    /** @nocollapse */
    TabTitleComponent.ctorParameters = function () { return []; };
    TabTitleComponent.propDecorators = {
        "titleDatas": [{ type: core_1.Input },],
        "tabTitleChangeEvent": [{ type: core_1.Output },],
    };
    return TabTitleComponent;
}());
exports.TabTitleComponent = TabTitleComponent;
//# sourceMappingURL=tab.title.component.js.map